<script lang="ts">
  import { Button, Col, FormGroup, Input, InputGroup, Label, Row, Table } from 'sveltestrap';
  import type { ActiveChallenge, ChallengeFile } from '@models/Challenges';
  import { postFiles } from '@utils/FileStoreageApi.js';
  import type { NullableEventRole } from '@auth/models';
  import { InsertChallengeFile } from '@queries/Challenges.Files';

  export let activeChallenge: ActiveChallenge;
  export let deleteAtleastOne: (table: string, where: string) => Promise<boolean>;
  export let queryRole: NullableEventRole;
  let pendingFiles: FileList | null = null;
  let feedback: string | null = null;

  async function uploadFiles(e: Event) {
    feedback = null;
    if (!pendingFiles?.length) return; // disabled if no pending files available
    e.stopPropagation();
    e.preventDefault();

    console.log(pendingFiles);
    let response;
    // upload files
    try {
      response = await postFiles(pendingFiles);
      console.log(response);
    } catch (err) {
      if (err.message?.includes('status code 413')) {
        feedback = 'A file was too Large';
      } else {
        feedback = err.message || err;
      }
      console.error(err);
    }

    for (const file of response.data.processedFiles) {
      // create challenges.files
      const response = await InsertChallengeFile(
        {
          challenge_id: activeChallenge.challenge_id,
          event_id: activeChallenge.event_id,
          file_id: file.id,
        },
        { role: queryRole },
      );
      // Add to results array
      // update Active Challenge
      activeChallenge.files?.push(response.insert_challenges_files_one);
    }

    // trigger reload
    activeChallenge = activeChallenge;
    // reset file upload
    pendingFiles = null;
  }

  async function deleteFile(e: Event, file: ChallengeFile): Promise<boolean> {
    e.preventDefault();
    e.stopPropagation();
    let success;
    // todo need to delete from storage.files and actual file in bucket?
    success = await deleteAtleastOne(
      'delete_challenges_files',
      `{
          challenge_id: {_eq: ${JSON.stringify(activeChallenge.challenge_id)}}
          event_id: {_eq: ${JSON.stringify(file.event_id)}}
          file_id: {_eq: ${JSON.stringify(file.file_id)}}
         }`,
    );
    if (!success) console.error(`No rows affected when deleting flag '${file.file_id}'`);
    if (success) activeChallenge.files = activeChallenge.files?.filter((f) => f.file_id !== file.file_id);
  }
</script>

<FormGroup>
  <Label class="hstack">
    <span class="fs-3 me-5">Files</span>
    <InputGroup size="sm" class="ms-5">
      <Input multiple type="file" bind:files={pendingFiles} />
      <Button
        class="clickable"
        disabled={!pendingFiles?.length}
        color={pendingFiles?.length > 0 ? 'success' : 'secondary'}
        on:click={uploadFiles}
      >
        Upload
      </Button>
    </InputGroup>
  </Label>

  {#if activeChallenge.files.length > 0}
    <Table dark>
      <thead>
        <th class="py-1 px-2">Size</th>
        <th class="py-1 px-2">Name</th>
        <th class="py-1 px-2">Last Updated</th>
        <th />
      </thead>
      <tbody>
        {#each activeChallenge.files as file (file.file_id)}
          <tr>
            <td>{file.file.size}</td>
            <td>{file.file.name}</td>
            <td>{file.file.updatedAt}</td>
            <td>
              <i
                class="fa-solid fa-trash-can text-danger clickable"
                on:click={(e) => deleteFile(e, file, activeChallenge)}
              />
            </td>
          </tr>
        {/each}
      </tbody>
    </Table>
  {/if}
</FormGroup>
